diff --git a/args.gn b/args.gn
new file mode 100644
index 000000000000..94bf0c3197a6
--- /dev/null
+++ b/args.gn
@@ -0,0 +1,2 @@
+is_debug = false
+
diff --git a/chrome/browser/extensions/BUILD.gn b/chrome/browser/extensions/BUILD.gn
index 6cfbb6366b76..e558c1fd172a 100644
--- a/chrome/browser/extensions/BUILD.gn
+++ b/chrome/browser/extensions/BUILD.gn
@@ -161,6 +161,8 @@ static_library("extensions") {
     "api/developer_private/inspectable_views_finder.h",
     "api/developer_private/show_permissions_dialog_helper.cc",
     "api/developer_private/show_permissions_dialog_helper.h",
+    "api/developer_private/show_suspicious_actions_dialog_helper.cc",
+    "api/developer_private/show_suspicious_actions_dialog_helper.h",
     "api/dial/dial_api.cc",
     "api/dial/dial_api.h",
     "api/dial/dial_api_factory.cc",
diff --git a/chrome/browser/extensions/api/developer_private/developer_private_api.cc b/chrome/browser/extensions/api/developer_private/developer_private_api.cc
index 81ec02f14c9b..b126c7e8dd36 100644
--- a/chrome/browser/extensions/api/developer_private/developer_private_api.cc
+++ b/chrome/browser/extensions/api/developer_private/developer_private_api.cc
@@ -22,6 +22,7 @@
 #include "chrome/browser/extensions/api/developer_private/entry_picker.h"
 #include "chrome/browser/extensions/api/developer_private/extension_info_generator.h"
 #include "chrome/browser/extensions/api/developer_private/show_permissions_dialog_helper.h"
+#include "chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.h"
 #include "chrome/browser/extensions/api/extension_action/extension_action_api.h"
 #include "chrome/browser/extensions/devtools_util.h"
 #include "chrome/browser/extensions/extension_commands_global_registry.h"
@@ -788,6 +789,39 @@ void DeveloperPrivateShowPermissionsDialogFunction::Finish() {
   Respond(NoArguments());
 }
 
+DeveloperPrivateShowSuspiciousActionsDialogFunction::
+DeveloperPrivateShowSuspiciousActionsDialogFunction() {}
+
+DeveloperPrivateShowSuspiciousActionsDialogFunction::
+~DeveloperPrivateShowSuspiciousActionsDialogFunction() {}
+
+ExtensionFunction::ResponseAction
+DeveloperPrivateShowSuspiciousActionsDialogFunction::Run() {
+  std::unique_ptr<developer::ShowSuspiciousActionsDialog::Params> params(
+      developer::ShowSuspiciousActionsDialog::Params::Create(*args_));
+  EXTENSION_FUNCTION_VALIDATE(params);
+
+  const Extension* target_extension = GetExtensionById(params->extension_id);
+  if (!target_extension)
+    return RespondNow(Error(kNoSuchExtensionError));
+
+  content::WebContents* web_contents = GetSenderWebContents();
+  if (!web_contents)
+    return RespondNow(Error(kCouldNotFindWebContentsError));
+
+  ShowSuspiciousActionsDialogHelper::Show(
+      browser_context(),
+      web_contents,
+      target_extension,
+      source_context_type() == Feature::WEBUI_CONTEXT,
+      base::Bind(&DeveloperPrivateShowSuspiciousActionsDialogFunction::Finish, this));
+  return RespondLater();
+}
+
+void DeveloperPrivateShowSuspiciousActionsDialogFunction::Finish() {
+  Respond(NoArguments());
+}
+
 DeveloperPrivateLoadUnpackedFunction::DeveloperPrivateLoadUnpackedFunction() {}
 
 ExtensionFunction::ResponseAction DeveloperPrivateLoadUnpackedFunction::Run() {
diff --git a/chrome/browser/extensions/api/developer_private/developer_private_api.h b/chrome/browser/extensions/api/developer_private/developer_private_api.h
index 7b0d29f8ad3d..d652267012b4 100644
--- a/chrome/browser/extensions/api/developer_private/developer_private_api.h
+++ b/chrome/browser/extensions/api/developer_private/developer_private_api.h
@@ -390,6 +390,23 @@ class DeveloperPrivateShowPermissionsDialogFunction
   DISALLOW_COPY_AND_ASSIGN(DeveloperPrivateShowPermissionsDialogFunction);
 };
 
+class DeveloperPrivateShowSuspiciousActionsDialogFunction
+    : public DeveloperPrivateAPIFunction {
+ public:
+  DECLARE_EXTENSION_FUNCTION("developerPrivate.showSuspiciousActionsDialog",
+                             DEVELOPERPRIVATE_PERMISSIONS);
+  DeveloperPrivateShowSuspiciousActionsDialogFunction();
+
+ protected:
+  // DeveloperPrivateAPIFunction:
+  ~DeveloperPrivateShowSuspiciousActionsDialogFunction() override;
+  ResponseAction Run() override;
+
+  void Finish();
+
+  DISALLOW_COPY_AND_ASSIGN(DeveloperPrivateShowSuspiciousActionsDialogFunction);
+};
+
 class DeveloperPrivateChooseEntryFunction : public UIThreadExtensionFunction,
                                             public EntryPickerClient {
  protected:
diff --git a/chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.cc b/chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.cc
new file mode 100644
index 000000000000..a53808fe5f70
--- /dev/null
+++ b/chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.cc
@@ -0,0 +1,60 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.h"
+
+#include <utility>
+
+#include "apps/saved_files_service.h"
+#include "base/metrics/histogram_macros.h"
+#include "chrome/browser/apps/app_load_service.h"
+#include "chrome/browser/profiles/profile.h"
+#include "chrome/browser/ui/apps/app_info_dialog.h"
+#include "content/public/browser/web_contents.h"
+#include "extensions/browser/api/device_permissions_manager.h"
+#include "extensions/browser/extension_registry.h"
+#include "extensions/common/extension.h"
+#include "extensions/common/permissions/permissions_data.h"
+#include "chrome/browser/ui/views/extensions/extension_suspicious_actions_view.h"
+
+namespace extensions {
+
+ShowSuspiciousActionsDialogHelper::ShowSuspiciousActionsDialogHelper(
+    const base::Closure& on_complete)
+    : on_complete_(on_complete) {
+}
+
+ShowSuspiciousActionsDialogHelper::~ShowSuspiciousActionsDialogHelper() {
+}
+
+// static
+void ShowSuspiciousActionsDialogHelper::Show(content::BrowserContext* browser_context,
+                                             content::WebContents* web_contents,
+                                             const Extension* extension,
+                                             bool from_webui,
+                                             const base::Closure& on_complete) {
+  Profile* profile = Profile::FromBrowserContext(browser_context);
+  // ShowSuspiciousActionsDialogHelper manages its own lifetime.
+  ShowSuspiciousActionsDialogHelper* helper =
+      new ShowSuspiciousActionsDialogHelper(on_complete);
+  helper->ShowSuspiciousActionsDialog(browser_context, profile, web_contents, extension);
+}
+
+void ShowSuspiciousActionsDialogHelper::ShowSuspiciousActionsDialog(
+    content::BrowserContext* browser_context,
+    Profile* profile,
+    content::WebContents* web_contents,
+    const Extension* extension) {
+  ExtensionSuspiciousActionsView::ShowDialog(
+    base::Bind(&ShowSuspiciousActionsDialogHelper::OnDone, base::Unretained(this)),
+    browser_context, profile, web_contents, extension
+  );
+}
+
+void ShowSuspiciousActionsDialogHelper::OnDone() {
+  on_complete_.Run();
+  delete this;
+}
+
+}  // namespace extensions
diff --git a/chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.h b/chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.h
new file mode 100644
index 000000000000..9c8798556d62
--- /dev/null
+++ b/chrome/browser/extensions/api/developer_private/show_suspicious_actions_dialog_helper.h
@@ -0,0 +1,49 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CHROME_BROWSER_EXTENSIONS_API_DEVELOPER_PRIVATE_SHOW_SUSPICIOUS_ACTIONS_DIALOG_HELPER_H_
+#define CHROME_BROWSER_EXTENSIONS_API_DEVELOPER_PRIVATE_SHOW_SUSPICIOUS_ACTIONS_DIALOG_HELPER_H_
+
+#include <memory>
+
+#include "base/bind.h"
+#include "base/macros.h"
+#include "chrome/browser/extensions/extension_install_prompt.h"
+
+class Profile;
+
+namespace content {
+class BrowserContext;
+class WebContents;
+}
+
+namespace extensions {
+class Extension;
+
+class ShowSuspiciousActionsDialogHelper {
+ public:
+  static void Show(content::BrowserContext* browser_context,
+                   content::WebContents* web_contents,
+                   const Extension* extension,
+                   bool from_webui,
+                   const base::Closure& on_complete);
+ private:
+  ShowSuspiciousActionsDialogHelper(const base::Closure& on_complete);
+  ~ShowSuspiciousActionsDialogHelper();  // Manages its own lifetime.
+
+  void ShowSuspiciousActionsDialog(content::BrowserContext* browser_context,
+                                   Profile* profile, 
+                                   content::WebContents* web_contents,
+                                   const Extension* extension);
+  void OnDone();
+
+  base::Closure on_complete_;
+  std::string extension_id_;
+
+  DISALLOW_COPY_AND_ASSIGN(ShowSuspiciousActionsDialogHelper);
+};
+
+}  // namespace extensions
+
+#endif  // CHROME_BROWSER_EXTENSIONS_API_DEVELOPER_PRIVATE_SHOW_SUSPICIOUS_ACTIONS_DIALOG_HELPER_H_
diff --git a/chrome/browser/resources/extensions/extension_list.js b/chrome/browser/resources/extensions/extension_list.js
index df40e770919c..f1c6fd25ae00 100644
--- a/chrome/browser/resources/extensions/extension_list.js
+++ b/chrome/browser/resources/extensions/extension_list.js
@@ -140,6 +140,12 @@ cr.define('extensions', function() {
     permissionsPromptIsShowing_: false,
 
     /**
+     * Indicates whether a permissions prompt is showing.
+     * @private {boolean}
+     */
+    suspiciousActionsPromptIsShowing_: false,
+
+    /**
      * Whether or not any initial navigation (like scrolling to an extension,
      * or opening an options page) has occurred.
      * @private {boolean}
@@ -431,6 +437,16 @@ cr.define('extensions', function() {
         e.preventDefault();
       });
 
+      wrapper.setupColumn('details', '.suspicious-actions-link', 'click', function(e) {
+        if (!this.suspiciousActionsPromptIsShowing_) {
+          chrome.developerPrivate.showSuspiciousActionsDialog(extension.id, function() {
+            this.suspiciousActionsPromptIsShowing_ = false;
+          }.bind(this));
+          this.suspiciousActionsPromptIsShowing_ = true;
+        }
+        e.preventDefault();
+      });
+
       wrapper.setupColumn('options', '.options-button', 'click', function(e) {
         this.showEmbeddedExtensionOptions_(extension.id, false);
         e.preventDefault();
diff --git a/chrome/browser/ui/BUILD.gn b/chrome/browser/ui/BUILD.gn
index 7e322e7b3440..9bbd0a4c06aa 100644
--- a/chrome/browser/ui/BUILD.gn
+++ b/chrome/browser/ui/BUILD.gn
@@ -1503,6 +1503,12 @@ split_static_library("ui") {
       "views/extensions/extension_install_dialog_view.h",
       "views/extensions/extension_keybinding_registry_views.cc",
       "views/extensions/extension_keybinding_registry_views.h",
+      "views/extensions/extension_action_prompt_view.cc",
+      "views/extensions/extension_action_prompt_view.h",
+      "views/extensions/extension_suspicious_actions_view.cc",
+      "views/extensions/extension_suspicious_actions_view.h",
+      "views/extensions/suspicious_action_config.cc",
+      "views/extensions/suspicious_action_config.h",
       "views/frame/native_widget_mac_frameless_nswindow.h",
       "views/frame/native_widget_mac_frameless_nswindow.mm",
       "views/global_error_bubble_view.cc",
diff --git a/chrome/browser/ui/browser.cc b/chrome/browser/ui/browser.cc
index 3d376c9b05bb..17faa92c8778 100644
--- a/chrome/browser/ui/browser.cc
+++ b/chrome/browser/ui/browser.cc
@@ -211,6 +211,7 @@
 #include "ui/base/window_open_disposition.h"
 #include "ui/gfx/geometry/point.h"
 #include "ui/shell_dialogs/selected_file_info.h"
+#include "chrome/browser/ui/views/extensions/extension_action_prompt_view.cc"
 
 #if defined(OS_WIN)
 #include <windows.h>
@@ -1738,6 +1739,26 @@ content::JavaScriptDialogManager* Browser::GetJavaScriptDialogManager(
   return JavaScriptDialogTabHelper::FromWebContents(source);
 }
 
+void Browser::ShowExtensionActionPromptView(WebContents* source,
+                                            const base::string16& message,
+                                            const SuspiciousExtensionAction& extension_action,
+                                            const SensitiveElement& sensitive_element,
+                                            const GURL& extension_url,
+                                            const GURL& frame_url,
+                                            const DialogClosedCallback& callback) {
+  gfx::NativeWindow parent_window = window_->GetNativeWindow();
+  ExtensionActionPromptView::ShowDialog(
+    source,
+    parent_window,
+    message,
+    extension_action,
+    sensitive_element,
+    extension_url,
+    frame_url,
+    callback
+  );
+}
+
 content::ColorChooser* Browser::OpenColorChooser(
       WebContents* web_contents,
       SkColor initial_color,
diff --git a/chrome/browser/ui/browser.h b/chrome/browser/ui/browser.h
index 4ceb67f0686a..3d11620d668f 100644
--- a/chrome/browser/ui/browser.h
+++ b/chrome/browser/ui/browser.h
@@ -644,6 +644,13 @@ class Browser : public TabStripModelObserver,
       content::WebContents* web_contents) override;
   content::JavaScriptDialogManager* GetJavaScriptDialogManager(
       content::WebContents* source) override;
+  void ShowExtensionActionPromptView(content::WebContents* source,
+                                     const base::string16& message,
+                                     const SuspiciousExtensionAction& extension_action,
+                                     const SensitiveElement& sensitive_element,
+                                     const GURL& extension_url,
+                                     const GURL& frame_url,
+                                     const DialogClosedCallback& callback) override;
   content::ColorChooser* OpenColorChooser(
       content::WebContents* web_contents,
       SkColor color,
diff --git a/chrome/browser/ui/views/extensions/extension_action_prompt_view.cc b/chrome/browser/ui/views/extensions/extension_action_prompt_view.cc
new file mode 100644
index 000000000000..416a3be941be
--- /dev/null
+++ b/chrome/browser/ui/views/extensions/extension_action_prompt_view.cc
@@ -0,0 +1,389 @@
+// Copyright (c) 2012 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "chrome/browser/ui/views/extensions/extension_action_prompt_view.h"
+
+#include <stddef.h>
+#include <algorithm>
+#include <string>
+#include <utility>
+#include <vector>
+
+#include "base/memory/weak_ptr.h"
+#include "base/callback_helpers.h"
+#include "base/callback.h"
+#include "base/command_line.h"
+#include "base/compiler_specific.h"
+#include "base/i18n/rtl.h"
+#include "base/macros.h"
+#include "base/metrics/histogram_macros.h"
+#include "base/strings/string_util.h"
+#include "base/strings/utf_string_conversions.h"
+#include "chrome/app/vector_icons/vector_icons.h"
+#include "chrome/browser/browser_process.h"
+#include "chrome/browser/extensions/api/experience_sampling_private/experience_sampling.h"
+#include "chrome/browser/extensions/extension_install_prompt_show_params.h"
+#include "chrome/browser/profiles/profile.h"
+#include "chrome/browser/ui/browser.h"
+#include "chrome/browser/ui/scoped_tabbed_browser_displayer.h"
+#include "chrome/common/extensions/extension_constants.h"
+#include "chrome/grit/generated_resources.h"
+#include "chrome/installer/util/browser_distribution.h"
+#include "components/constrained_window/constrained_window_views.h"
+#include "content/public/browser/browser_thread.h"
+#include "content/public/browser/page_navigator.h"
+#include "content/public/browser/web_contents.h"
+#include "extensions/common/extension.h"
+#include "extensions/common/extension_urls.h"
+#include "ui/base/l10n/l10n_util.h"
+#include "ui/views/controls/button/checkbox.h"
+#include "ui/base/resource/resource_bundle.h"
+#include "ui/gfx/color_palette.h"
+#include "ui/gfx/paint_vector_icon.h"
+#include "ui/gfx/text_utils.h"
+#include "ui/native_theme/common_theme.h"
+#include "ui/views/border.h"
+#include "ui/views/controls/button/image_button.h"
+#include "ui/views/controls/image_view.h"
+#include "ui/views/controls/label.h"
+#include "ui/views/controls/link.h"
+#include "ui/views/controls/scroll_view.h"
+#include "ui/views/controls/separator.h"
+#include "ui/views/layout/box_layout.h"
+#include "ui/views/layout/grid_layout.h"
+#include "ui/views/layout/layout_constants.h"
+#include "ui/views/widget/widget.h"
+#include "ui/base/ui_base_types.h"
+#include "ui/gfx/font_list.h"
+#include "components/url_formatter/elide_url.h"
+#include "content/public/browser/web_contents.h"
+#include "base/strings/string_piece.h"
+#include "url/gurl.h"
+#include "extensions/common/extension_set.h"
+#include "extensions/browser/extension_registry.h"
+#include "extensions/common/constants.h"
+#include "extensions/common/manifest_handlers/icons_handler.h"
+#include "extensions/browser/image_loader.h"
+#include "base/bind.h"
+#include "chrome/browser/extensions/extension_util.h"
+
+namespace {
+  const int kRightColumnWidth = 300;
+  const int kIconSize = 64;
+
+  // Returns gfx::ImageSkia for the default icon.
+  gfx::ImageSkia GetDefaultIconImage(bool is_app) {
+    return  is_app ? extensions::util::GetDefaultAppIcon() : extensions::util::GetDefaultExtensionIcon();
+  }
+}
+
+ExtensionActionPromptView::ExtensionActionPromptView(gfx::NativeWindow parent_window,
+                                                     const base::string16& message,
+                                                     const SensitiveElement& sensitive_element,
+                                                     const GURL& frame_url,
+                                                     const content::WebContentsDelegate::DialogClosedCallback& callback,
+                                                     const extensions::Extension* extension,
+                                                     const gfx::Image& image,
+                                                     bool should_show_dialog)
+                                                   : message_(message),
+                                                     frame_url_(frame_url),
+                                                     callback_(callback),
+                                                     parent_window_(parent_window),
+                                                     extension_(extension),
+                                                     sensitive_element_(sensitive_element) {
+   if (!should_show_dialog) {
+     if (!callback_.is_null()) {
+       base::ResetAndReturn(&callback_).Run(true);
+     }
+     return;
+   }
+
+   // If we only want to show the dialog for sensitive elements and the element
+   // is not sensitive, return the dialog.
+   if (Cache()[key_] == RememberPreference::ALWAYS_ALLOW_IF_NOT_SENSITIVE &&
+       sensitive_element_ == SensitiveElement::NOT_SENSITIVE) {
+     if (!callback_.is_null()) {
+       base::ResetAndReturn(&callback_).Run(true);
+     }
+     return;
+   }
+
+   // If the user choice has been cached, don't display the dialog.
+   key_ = base::UTF8ToUTF16(extension_->name()) + message_;
+   if (Cache()[key_] == RememberPreference::ALWAYS_PREVENT) {
+     if (!callback_.is_null()) {
+       base::ResetAndReturn(&callback_).Run(false);
+     }
+     return;
+   } else if (Cache()[key_] == RememberPreference::ALWAYS_ALLOW) {
+     if (!callback_.is_null()) {
+       base::ResetAndReturn(&callback_).Run(true);
+     }
+     return;
+   }
+
+   SetLayoutManager(new views::BoxLayout(
+       views::BoxLayout::kHorizontal, views::kButtonHEdgeMarginNew,
+       views::kPanelVertMargin, views::kRelatedControlHorizontalSpacing));
+
+   gfx::ImageSkia icon;
+   if (image.IsEmpty()) {
+     icon = GetDefaultIconImage(extension_->is_app());
+   } else {
+     icon = *image.ToImageSkia();
+   }
+
+   views::ImageView* iconView = new views::ImageView();
+   DCHECK_GE(icon.width(), kIconSize);
+   DCHECK_GE(icon.height(), kIconSize);
+   iconView->SetImageSize(gfx::Size(kIconSize, kIconSize));
+   iconView->SetImage(icon);
+   AddChildView(iconView);
+
+   base::string16 url_string =
+       url_formatter::ElideHost(frame_url_, gfx::FontList(), 350);
+   if (url_string.length() > 0) {
+     url_string = base::ASCIIToUTF16(" on the page \"") + url_string;
+   }
+
+   base::string16 sensitive_element_message = base::ASCIIToUTF16("");
+   if (sensitive_element_ == SensitiveElement::SENSITIVE) {
+     sensitive_element_message = base::ASCIIToUTF16("\n\nNote: Action performed on a non-sensitive element");
+   } else if (sensitive_element_ == SensitiveElement::NOT_SENSITIVE) {
+     sensitive_element_message = base::ASCIIToUTF16("\n\nWarning: Action performed on a sensitive element");
+   }
+
+   views::Label* heading_ = new views::Label(
+     base::ASCIIToUTF16("The \"") + base::UTF8ToUTF16(extension_->name()) +
+     base::ASCIIToUTF16("\" extension is attempting to ") + message_ +
+     url_string + base::ASCIIToUTF16("\". Do you want to allow or prevent this action from occuring?") +
+     sensitive_element_message
+   );
+   heading_->SetMultiLine(true);
+   heading_->SetHorizontalAlignment(gfx::ALIGN_LEFT);
+   heading_->SetAllowCharacterBreak(true);
+   heading_->SizeToFit(kRightColumnWidth);
+   AddChildView(heading_);
+
+   constrained_window::CreateBrowserModalDialogViews(this, parent_window_)->Show();
+}
+
+
+void ExtensionActionPromptView::ShouldShowDialogWithImage(content::WebContents* source,
+                                                         gfx::NativeWindow parent_window,
+                                                         const base::string16& message,
+                                                         const SensitiveElement& sensitive_element,
+                                                         const GURL& frame_url,
+                                                         const content::WebContentsDelegate::DialogClosedCallback& callback,
+                                                         const extensions::Extension* extension,
+                                                         const gfx::Image& image,
+                                                         bool should_show_dialog) {
+
+  new ExtensionActionPromptView(parent_window,
+                                message,
+                                sensitive_element,
+                                frame_url,
+                                callback,
+                                extension,
+                                image,
+                                should_show_dialog);
+}
+
+void ExtensionActionPromptView::ShowDialogWithImage(content::WebContents* source,
+                                                    gfx::NativeWindow parent_window,
+                                                    const base::string16& message,
+                                                    const SuspiciousExtensionAction& extension_action,
+                                                    const SensitiveElement& sensitive_element,
+                                                    const GURL& frame_url,
+                                                    const content::WebContentsDelegate::DialogClosedCallback& callback,
+                                                    const extensions::Extension* extension,
+                                                    const gfx::Image& image) {
+
+   (new SuspiciousActionConfig(source->GetBrowserContext()))->IsActionSuspicious(
+     extension->id(),
+     extension_action,
+     base::Bind(
+        &ExtensionActionPromptView::ShouldShowDialogWithImage,
+        source, parent_window, message, sensitive_element, frame_url, callback, extension, image
+     )
+   );
+}
+
+void ExtensionActionPromptView::ShowDialog(content::WebContents* source,
+                                           gfx::NativeWindow parent_window,
+                                           const base::string16& message,
+                                           const SuspiciousExtensionAction& extension_action,
+                                           const SensitiveElement& sensitive_element,
+                                           const GURL& extension_url,
+                                           const GURL& frame_url,
+                                           const content::WebContentsDelegate::DialogClosedCallback& callback) {
+
+   const extensions::Extension* extension = extensions::ExtensionRegistry::Get(
+     source->GetBrowserContext()
+   )->enabled_extensions().GetExtensionOrAppByURL(extension_url);
+
+   // Bookmark apps may not have 128x128 icons so accept 64x64 icons.
+   const int icon_size = extension->from_bookmark()
+                             ? extension_misc::EXTENSION_ICON_SMALL * 2
+                             : extension_misc::EXTENSION_ICON_LARGE;
+   extensions::ExtensionResource image = extensions::IconsInfo::GetIconResource(
+       extension, icon_size, ExtensionIconSet::MATCH_BIGGER);
+
+   // Load the image asynchronously. The response will be sent to OnImageLoaded.
+   extensions::ImageLoader* loader = extensions::ImageLoader::Get(source->GetBrowserContext());
+
+   std::vector<extensions::ImageLoader::ImageRepresentation> images_list;
+   images_list.push_back(extensions::ImageLoader::ImageRepresentation(
+       image,
+       extensions::ImageLoader::ImageRepresentation::NEVER_RESIZE,
+       gfx::Size(),
+       ui::SCALE_FACTOR_100P));
+   loader->LoadImagesAsync(
+     extension, images_list,
+     base::Bind(&ExtensionActionPromptView::ShowDialogWithImage,
+                source, parent_window, message, extension_action, sensitive_element, frame_url, callback, extension)
+   );
+}
+
+ExtensionActionPromptView::~ExtensionActionPromptView() {
+  ExtensionActionPromptView::Cancel();
+}
+
+base::string16 ExtensionActionPromptView::GetDialogButtonLabel(ui::DialogButton button) const {
+  switch (button) {
+    case ui::DIALOG_BUTTON_OK:
+      return base::ASCIIToUTF16("Allow");
+    case ui::DIALOG_BUTTON_CANCEL:
+      return base::ASCIIToUTF16("Prevent");
+    default:
+      NOTREACHED();
+      return base::string16();
+  }
+}
+
+// Cancel prevents extension action
+bool ExtensionActionPromptView::Cancel() {
+  if (!callback_.is_null()) {
+    base::ResetAndReturn(&callback_).Run(false);
+  }
+  return true;
+}
+
+// Close and Accept allow extension action
+bool ExtensionActionPromptView::Close() {
+  if (!callback_.is_null()) {
+    base::ResetAndReturn(&callback_).Run(true);
+  }
+  return true;
+}
+
+// Close and Accept allow extension action
+bool ExtensionActionPromptView::Accept() {
+  if (!callback_.is_null()) {
+    base::ResetAndReturn(&callback_).Run(true);
+  }
+  return true;
+}
+
+bool ExtensionActionPromptView::ShouldShowWindowTitle() const {
+  return true;
+}
+
+base::string16 ExtensionActionPromptView::GetWindowTitle() const {
+  return base::ASCIIToUTF16("Suspicious Extension Action Alert");
+}
+
+bool ExtensionActionPromptView::ShouldDefaultButtonBeBlue() const {
+  return true;
+}
+
+ui::ModalType ExtensionActionPromptView::GetModalType() const {
+  return ui::MODAL_TYPE_WINDOW;
+}
+
+views::View* ExtensionActionPromptView::CreateExtraView() {
+  views::View* checkboxes = new views::View();
+  checkboxes->SetLayoutManager(new views::BoxLayout(views::BoxLayout::kVertical, 0, 0, 0));
+
+  always_allow_non_sensitive_checkbox_ = nullptr;
+  if (sensitive_element_ != SensitiveElement::NOT_APPLICABLE) {
+    always_allow_non_sensitive_checkbox_ = new views::Checkbox(
+      base::ASCIIToUTF16("Always allow for non-sensitive elements")
+    );
+    always_allow_non_sensitive_checkbox_->SetChecked(
+      Cache()[key_] == RememberPreference::ALWAYS_ALLOW_IF_NOT_SENSITIVE
+    );
+    always_allow_non_sensitive_checkbox_->set_listener(this);
+    checkboxes->AddChildView(always_allow_non_sensitive_checkbox_);
+  }
+
+  always_allow_checkbox_ = new views::Checkbox(base::ASCIIToUTF16("Always allow"));
+  always_allow_checkbox_->set_listener(this);
+  checkboxes->AddChildView(always_allow_checkbox_);
+
+  always_prevent_checkbox_ = new views::Checkbox(base::ASCIIToUTF16("Always prevent"));
+  always_prevent_checkbox_->set_listener(this);
+  checkboxes->AddChildView(always_prevent_checkbox_);
+
+  return checkboxes;
+}
+
+void ExtensionActionPromptView::ButtonPressed(views::Button* sender,
+                                              const ui::Event& event) {
+  if (sender == always_allow_non_sensitive_checkbox_) {
+    if (always_allow_non_sensitive_checkbox_->checked()) {
+      Cache()[key_] = RememberPreference::ALWAYS_ALLOW_IF_NOT_SENSITIVE;
+      always_prevent_checkbox_->SetChecked(false);
+      always_prevent_checkbox_->SetState(views::Checkbox::ButtonState::STATE_DISABLED);
+      if (sensitive_element_ == SensitiveElement::NOT_SENSITIVE) {
+        GetDialogClientView()->cancel_button()->SetState(views::LabelButton::ButtonState::STATE_DISABLED);
+      }
+    } else {
+      Cache()[key_] = RememberPreference::DONT_REMEMBER;
+      always_prevent_checkbox_->SetState(views::Checkbox::ButtonState::STATE_NORMAL);
+      GetDialogClientView()->cancel_button()->SetState(views::LabelButton::ButtonState::STATE_NORMAL);
+    }
+  }
+
+  if (sender == always_allow_checkbox_) {
+    if (always_allow_checkbox_->checked()) {
+      Cache()[key_] = RememberPreference::ALWAYS_ALLOW;
+      if (always_allow_non_sensitive_checkbox_ != nullptr) {
+        always_allow_non_sensitive_checkbox_->SetChecked(true);
+        always_allow_non_sensitive_checkbox_->SetState(views::Checkbox::ButtonState::STATE_DISABLED);
+      }
+      always_prevent_checkbox_->SetChecked(false);
+      always_prevent_checkbox_->SetState(views::Checkbox::ButtonState::STATE_DISABLED);
+      GetDialogClientView()->cancel_button()->SetState(views::LabelButton::ButtonState::STATE_DISABLED);
+    } else {
+      Cache()[key_] = RememberPreference::DONT_REMEMBER;
+      if (always_allow_non_sensitive_checkbox_ != nullptr) {
+        always_allow_non_sensitive_checkbox_->SetChecked(false);
+        always_allow_non_sensitive_checkbox_->SetState(views::Checkbox::ButtonState::STATE_NORMAL);
+      }
+      always_prevent_checkbox_->SetState(views::Checkbox::ButtonState::STATE_NORMAL);
+      GetDialogClientView()->cancel_button()->SetState(views::LabelButton::ButtonState::STATE_NORMAL);
+    }
+  }
+
+  if (sender == always_prevent_checkbox_) {
+    if (always_prevent_checkbox_->checked()) {
+      Cache()[key_] = RememberPreference::ALWAYS_PREVENT;
+      if (always_allow_non_sensitive_checkbox_ != nullptr) {
+        always_allow_non_sensitive_checkbox_->SetChecked(false);
+        always_allow_non_sensitive_checkbox_->SetState(views::Checkbox::ButtonState::STATE_DISABLED);
+      }
+      always_allow_checkbox_->SetChecked(false);
+      always_allow_checkbox_->SetState(views::Checkbox::ButtonState::STATE_DISABLED);
+      GetDialogClientView()->ok_button()->SetState(views::LabelButton::ButtonState::STATE_DISABLED);
+    } else {
+      Cache()[key_] = RememberPreference::DONT_REMEMBER;
+      if (always_allow_non_sensitive_checkbox_ != nullptr) {
+        always_allow_non_sensitive_checkbox_->SetState(views::Checkbox::ButtonState::STATE_NORMAL);
+      }
+      always_allow_checkbox_->SetState(views::Checkbox::ButtonState::STATE_NORMAL);
+      GetDialogClientView()->ok_button()->SetState(views::LabelButton::ButtonState::STATE_NORMAL);
+    }
+  }
+}
